<template>
  <div class="form-control rounded-lg ds-input ec-ds-search mt-3 mt-md-0">
    <input type="text" class="form-control" :aria-label="$t(config.textKeys.textFieldPlaceholder)"
      :placeholder="$t(config.textKeys.textFieldPlaceholder)" :value="getQuery"
      @input="event => setQuery(event.target.value)" @keyup="autocompleteSuggestions()" @keyup.enter="changeQuery()"
      @click="showSuggestions.active = true;"
      @keydown.down.prevent="handleArrowDown"
      @keydown.up.prevent="handleArrowUp"
      @keydown.enter="handleEnter">
    <ul ref="dropdownSuggestions" v-if="showSuggestions.active && isLoadingSuggestions" type="text"
      class="suggestedTitlesWrapper">
      <li v-for="i in 2" :key="i" class="loadingField">load</li>
    </ul>
    <ul ref="dropdownSuggestions" v-if="showSuggestions.active && !isLoadingSuggestions" type="text"
      class="suggestedTitlesWrapper">
      <span v-if="this.config.scope === 'dataset'">
        <li v-for="(item, index) in suggestedTitles " :key="index">
          <router-link :to="{ path: `/datasets/${item.id}` }" class="link">
          <div class="row g-2"> 
            <div class="col-1 auto-thumbnail">
              <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="black"
                class="bi bi-file-earmark" viewBox="0 0 16 16">
                <path
                  d="M14 4.5V14a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V2a2 2 0 0 1 2-2h5.5zm-3 0A1.5 1.5 0 0 1 9.5 3V1H4a1 1 0 0 0-1 1v12a1 1 0 0 0 1 1h8a1 1 0 0 0 1-1V4.5z" />
              </svg>
  
            </div>
            <div class="col-10">
              <div class="auto-title">
                {{ item.title[language] }}

                <span v-if="item.issued">({{ getYear(item.issued) }})</span>
              </div>
              <div class="auto-type">{{ this.config.scope }}</div>
            </div>
          </div>
          </router-link>
        </li>
      </span>
      <span v-if="this.config.scope === 'catalogue'">
    
        <li v-for="(item, index) in suggestedTitlesCatalogue " :key="index" :class="{ 'focused': currentFocusIndex === index }">

          <router-link :to="{ path: `/catalogues/${item.id}` }" class="link">
          <div class="row g-2">
            <img v-if="item.country" :src="getFlagImage(item.country.id)" :alt="`${item.country.id}-flag`"
              class="auto-image">
            <div v-else class="col-1 auto-thumbnail">
              <span>
                <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="black" class="bi bi-archive"
                  viewBox="0 0 16 16">
                  <path
                    d="M0 2a1 1 0 0 1 1-1h14a1 1 0 0 1 1 1v2a1 1 0 0 1-1 1v7.5a2.5 2.5 0 0 1-2.5 2.5h-9A2.5 2.5 0 0 1 1 12.5V5a1 1 0 0 1-1-1zm2 3v7.5A1.5 1.5 0 0 0 3.5 14h9a1.5 1.5 0 0 0 1.5-1.5V5zm13-3H1v2h14zM5 7.5a.5.5 0 0 1 .5-.5h5a.5.5 0 0 1 0 1h-5a.5.5 0 0 1-.5-.5" />
                </svg>
              </span>
            </div>
            <div class="col-10">
              <div class="auto-title">
                {{ item.title[language] }}
                <span v-if="item.issued">({{ getYear(item.issued) }})</span>
              </div>
              <div class="auto-type">{{ this.config.scope }}</div>
            </div>
          </div>
            </router-link>
        </li>
      </span>


      <!-- OLD -->

      <!-- <li v-for="(title, index) in suggestedTitles" :key="index" @click="setQuery(title); changeQuery()">
        <div class="row g-2">
          <div class="col-1 auto-thumbnail">
            <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-file-earmark" viewBox="0 0 16 16">
              <path d="M14 4.5V14a2 2 0 0 1-2 2H4a2 2 0 0 1-2-2V2a2 2 0 0 1 2-2h5.5zm-3 0A1.5 1.5 0 0 1 9.5 3V1H4a1 1 0 0 0-1 1v12a1 1 0 0 0 1 1h8a1 1 0 0 0 1-1V4.5z"/>
            </svg>
          </div>
          <div class="col-10">
            <div class="auto-title">
                      <span v-for="(part, index) in splitTitle(title)" :key="index">
                        <b v-if="part.isMatch">{{ part.text }}</b>
                        <span v-else>{{ part.text }}</span>
                      </span>
            </div> -->
      <!-- Make first Letter uppercase Function-->
      <!-- <div class="auto-type">{{this.config.scope}}</div>
          </div>
        </div>
      </li> -->
    </ul>
    <app-link v-if="config.textFieldHelpLink" :to="config.textFieldHelpLink" target="_blank">
      <i class="tooltip-icon material-icons small-icon align-right absolute text-dark pl-1" data-placement="right">
        help_outline
      </i>
    </app-link>


  </div>
</template>

<script>
import { reactive, ref } from "vue";
import { onClickOutside } from "@vueuse/core/index";
import { AppLink } from "@piveau/piveau-hub-ui-modules";

export default {
  name: "SearchBarTextField",
  setup() {
    const dropdownSuggestions = ref('dropdownSuggestions');
    const showSuggestions = reactive({
      active: false,
    });
    onClickOutside(dropdownSuggestions, () => {
      showSuggestions.active = false;
    });
    return {
      showSuggestions,
      onClickOutside,
    };
  },
  props: {
    config: Object,
    changeQuery: Function
  },
  components: {
    AppLink
  },
  data() {
    return {
      isLoadingSuggestions: false,
      lastKeyup: null,
      baseUrl: this.$env.api.baseUrl,
      suggestedTitles: [],
      suggestedTitlesCatalogue: [],
      language: this.$route.query.locale || "en",
      currentFocusIndex: -1,
    }
  },
  computed: {
    getQuery() {
      return this.$store.getters[`${this.config.getQuery[0]}/${this.config.getQuery[1]}`];
    },
  },
  methods: {
    handleArrowDown() {
    if (this.showSuggestions.active) {
      const maxIndex = this.config.scope === 'catalogue' 
        ? this.suggestedTitlesCatalogue.length - 1 
        : this.suggestedTitles.length - 1;
      this.currentFocusIndex = this.currentFocusIndex < maxIndex ? this.currentFocusIndex + 1 : 0;
    }
  },

  handleArrowUp() {
    if (this.showSuggestions.active) {
      const maxIndex = this.config.scope === 'catalogue' 
        ? this.suggestedTitlesCatalogue.length - 1 
        : this.suggestedTitles.length - 1;
      this.currentFocusIndex = this.currentFocusIndex > 0 ? this.currentFocusIndex - 1 : maxIndex;
    }
  },

  handleEnter() {
    if (this.currentFocusIndex >= 0) {
      const selectedItem = this.config.scope === 'catalogue' 
        ? this.suggestedTitlesCatalogue[this.currentFocusIndex]
        : this.suggestedTitles[this.currentFocusIndex];
      this.$router.push(`/${this.config.scope}s/${selectedItem.id}`);
    }
  },
    getYear(date) {
      return date ? date.substring(0, 4) : '';
    },
    getFlagImage(id) {
      // Use new URL to dynamically import the image
      return new URL(`../../../assets/img/flags/${id}.png`, import.meta.url).href;
    },
    setQuery(query) {
      this.$store.dispatch(`${this.config.setQuery[0]}/${this.config.setQuery[1]}`, query);
    },
    async autocompleteSuggestions() {
      this.isLoadingSuggestions = true
      // only the last keyup gets recognized -- improves performance!
      clearTimeout(this.lastKeyup)
      this.lastKeyup = setTimeout(async () => {
        let endpoint = this.baseUrl;

        let autocompleteRequest = endpoint + "/search" + "?q=" + this.getQuery + "&filters=" + "dataset" +
          "&autocomplete=true" +
          "&includes=title." + this.language + ",description." + this.language + ",keywords,country,issued,id"
        "&limit=10";

        let autocompleteRequestCatalogue = endpoint + "/search" + "?q=" + this.getQuery + "&filters=" + "catalogue" +
          "&autocomplete=true" +
          "&includes=title." + this.language + ",country,id"
        "&limit=10";

        try {
          const response = await fetch(autocompleteRequest);
          const responseCatalogue = await fetch(autocompleteRequestCatalogue);
          const data = await response.json();
          const dataCatalogue = await responseCatalogue.json();
          const results = data.result.results;
          const resultsCatalogue = dataCatalogue.result.results;
          this.suggestedTitles = results[0]['titles']
          this.suggestedTitlesCatalogue = resultsCatalogue[0]['titles']
        } catch (error) {
          console.log(error)
        }
        this.isLoadingSuggestions = false
      }, 500);
    },
    splitTitle(title) {
      const escapedQuery = this.getQuery.replace(/[-/\\^$*+?.()|[\]{}]/g, '\\$&'); // Escape special characters
      const regex = new RegExp(`(${escapedQuery})`, 'gi'); // Case-insensitive match
      const parts = title.split(regex); // Split by query matches

      // Map parts into objects with `text` and `isMatch` to control formatting
      return parts.map((part) => ({
        text: part,
        isMatch: part.toLowerCase() === this.getQuery.toLowerCase(),
      }));
    }
  },
  created() {
    let query = this.$route.query.query;
    this.setQuery(query || "");
  }
}
</script>

<style lang="scss" scoped>

.focused {
  background-color: #f5f5f5;
  color: #0e47cb;
  margin-left: 0.1rem;
}


.link {
  text-decoration:none;
  color: transparent;
}

router-link:focus {
  outline: none;
}
.form-control input[data-v-5fdd3dbc]:focus {
  border-color: none !important;
}

a:active {
  border: none !important;
}


.search-in {
  position: absolute;
  bottom: -45px;
  background-color: #515560 !important;
  color: #fff !important;
  padding: 6px 10px 5px 10px !important;
  font-size: 14px;
  font-weight: 100;
  border-radius: 30px;
}

.material-icons.small-icon {
  font-size: 20px;
}

.form-control {
  position: relative;
  border: none !important;
  padding: 0;

  .tooltip-icon {
    font-size: 15px;
    position: absolute;
    right: 25px;
    z-index: 2;
    top: 14px;
  }

  .suggestedTitlesWrapper {
    position: absolute;
    z-index: 99;
    background-color: white;
    padding: 0;
    width: 100%;
    border-right: 1px solid #404040;
    border-left: 1px solid #404040;
    border-bottom: 1px solid #404040;


    li {
      padding: 0.7rem;
      list-style: none;
      cursor: pointer;
      transition: margin 100ms ease-in-out;

      &:hover {
        color: #0e47cb;
        margin-left: 0.1rem;
        background-color: #f5f5f5;
      }
    }
  }

  input {
    display: block;
    width: 100%;
    height: 100%;
    margin: 0 !important;
    padding: .375rem .75rem;
    font-size: 1rem;
    font-weight: 400;
    line-height: 1.5;
    color: #495057;
    background-color: #fff;
    background-clip: padding-box;
    border: 1px solid #404040 !important;
    border-right: none !important;
    border-radius: 0.25rem 0.1rem 0.1rem 0.25rem;

    transition: border-color .15s ease-in-out, box-shadow .15s ease-in-out !important;

    &:focus {
      // border: 3px solid red;
      border-color: #4A82FA;
    }
  }
}

.loadingField:nth-child(odd) {

  overflow: hidden;
  animation: slide 1s infinite;
  background-image: linear-gradient(to right, #cecece, transparent);
  background-size: 200% 100%;

  &:hover {
    margin: 0 !important;
  }
}

@keyframes slide {
  0% {
    background-position: 0%;
  }

  50% {
    background-position: 100%;
  }

  100% {
    background-position: 0%;
  }
}

.loadingField {
  color: rgba(0, 0, 0, 0.0);

  &:hover {
    color: rgba(0, 0, 0, 0.0) !important;
  }
}

.auto-thumbnail {
  background-color: #F7F7F7;
  border-radius: 4px;
  max-height: 50px;
  margin-left: 15px;
}

.auto-image {
  max-height: 30px;
  max-width: 45px;
  margin-left: 15px;
  border-radius: 4px;
  margin-top: 8px;
}

.auto-thumbnail svg {
  top: 35%;
  position: absolute;
}

.auto-title {
  color: #404040;
}

.auto-type {
  font-size: 14px;
  color: #949494;
}

.auto-type::first-letter {
  text-transform: uppercase;
}

.material-icons.small-icon {
  font-size: 20px;
}

@media screen and (max-width: 767.5px) {

  .form-control {
    border: none;

    input {
      border: 1px solid #4A82FA !important;
    }
  }
}
</style>
